package Server1to1;
//------------------------------------------------------------------------------
// Class FileReader
// Author: Harald Bina
// last modified: xx.xx.1999
//------------------------------------------------------------------------------

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class FileReader {

//------------------------------------------------------------------------------
// Function readStaticDataFILE
// Reads Static Data from the Static Data File and creates the ItemList.
// File-loading Version
// Parameters: itemlist, Filename (of Static Data File)
//             StatusWindow (For printing out Error-massages and Infos)
//------------------------------------------------------------------------------
public static void readLibrary (boolean URL, ItemList itemlist, Map map, String Filename) {

  ServerMulti1to1.Lib_loaded = false;

  int i;
  int x = -1;

  int shelve_rows    = -1;
  int shelve_columns = -1;
  int curr_x_pos     = -1;
  int curr_y_pos     = 0;
  boolean shelve_rows_flag = false;
  boolean can_write = false;

  System.out.println("Loading Library...");

  if (URL) {   /****** Load from URL ******/

  InputStream data1;
  DataInputStream data2;
  try {URL fileURL = new URL(Filename);

    try {data1 = fileURL.openStream();
         data2 = new DataInputStream(data1);

    // check out number of items in file and init Types-Array
    itemlist.init_items(countEntriesURL(Filename));

    String line;                     // buffer for lines

    try {

    while ((line = data2.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            // read shelve description block------------------------------------
            if (parm.compareTo("SHELVE_ROWS") == 0) {
                shelve_rows = Integer.valueOf(st.nextToken()).intValue();
                shelve_rows_flag = true;
                }
            if (parm.compareTo("SHELVE_COLUMNS") == 0) {
                shelve_columns = Integer.valueOf(st.nextToken()).intValue();
                if (shelve_rows_flag) {
                    if ((shelve_columns > 0) && (shelve_rows > 0)) {
                      map.init_Map(shelve_columns,shelve_rows);
                      map.valid = true;
                      can_write = true;
                      }
                    }
                }
            if  (can_write) {

            if (parm.compareTo("SHELVE_LABEL") == 0) {
                curr_x_pos++;
                if (curr_x_pos > map.x_dim - 1) { curr_y_pos++; curr_x_pos = 0; };
                if (curr_y_pos <= map.y_dim - 1) {
                    map.labels[curr_x_pos][curr_y_pos] = "";
                    System.out.println("Label zugewiesen an Stelle " + curr_x_pos + " / " +curr_y_pos);
                    for (i = 0; i < words; i++) {
                    map.labels[curr_x_pos][curr_y_pos] = map.labels[curr_x_pos][curr_y_pos] + st.nextToken();
                    if (i != words - 1) map.labels[curr_x_pos][curr_y_pos] = map.labels[curr_x_pos][curr_y_pos] + " ";
                  }
                }
              }
            if (parm.compareTo("SHELVE_DESCR") == 0) {
                if (curr_y_pos <= map.y_dim - 1) {
                    map.descr[curr_x_pos][curr_y_pos] = "";
                    for (i = 0; i < words; i++) {
                    map.descr[curr_x_pos][curr_y_pos] = map.descr[curr_x_pos][curr_y_pos] + st.nextToken();
                    if (i != words - 1) map.descr[curr_x_pos][curr_y_pos] = map.descr[curr_x_pos][curr_y_pos] + " ";
                  }
                }
              }
            }
            // -----------------------------------------------------------------
            if (parm.compareTo("TITLE") == 0) {          // parse Keywords sequentially
                x++;
                itemlist.items[x].Key = x;
                for (i = 0; i < words; i++) {
                itemlist.items[x].title = itemlist.items[x].title + st.nextToken();
                if (i != words - 1) itemlist.items[x].title = itemlist.items[x].title + " ";
                } }
            if (parm.compareTo("WIDTH") == 0) {
                itemlist.items[x].width = st.nextToken();
                }
            if (parm.compareTo("HEIGHT") == 0) {
                itemlist.items[x].height = st.nextToken();
                }
            if (parm.compareTo("CREATOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].creator = itemlist.items[x].creator + st.nextToken();
                if (i != words - 1) itemlist.items[x].creator = itemlist.items[x].creator + " ";
                } }
            if (parm.compareTo("SUBJECT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].subject = itemlist.items[x].subject + st.nextToken();
                if (i != words - 1) itemlist.items[x].subject = itemlist.items[x].subject + " ";
                } }
            if (parm.compareTo("DESCRIPTION") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].description = itemlist.items[x].description + st.nextToken();
                if (i != words - 1) itemlist.items[x].description = itemlist.items[x].description + " ";
                } }
            if (parm.compareTo("PUBLISHER") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].publisher = itemlist.items[x].publisher + st.nextToken();
                if (i != words - 1) itemlist.items[x].publisher = itemlist.items[x].publisher + " ";
                } }
            if (parm.compareTo("CONTRIBUTOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].contributor = itemlist.items[x].contributor + st.nextToken();
                if (i != words - 1) itemlist.items[x].contributor = itemlist.items[x].contributor + " ";
                } }
            if (parm.compareTo("DATE") == 0) {
                itemlist.items[x].date = st.nextToken();
                }
            if (parm.compareTo("TYPE") == 0) {
                itemlist.items[x].type = st.nextToken();
                }
            if (parm.compareTo("FORMAT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].format = itemlist.items[x].format + st.nextToken();
                if (i != words - 1) itemlist.items[x].format = itemlist.items[x].format + " ";
                } }
            if (parm.compareTo("IDENTIFIER") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].identifier = itemlist.items[x].identifier + st.nextToken();
                if (i != words - 1) itemlist.items[x].identifier = itemlist.items[x].identifier + " ";
                } }
            if (parm.compareTo("SOURCE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].source = itemlist.items[x].source + st.nextToken();
                if (i != words - 1) itemlist.items[x].source = itemlist.items[x].source + " ";
                } }
            if (parm.compareTo("LANGUAGE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].language = itemlist.items[x].language + st.nextToken();
                if (i != words - 1) itemlist.items[x].language = itemlist.items[x].language + " ";
                } }
            if (parm.compareTo("RELATION") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].relation = itemlist.items[x].relation + st.nextToken();
                if (i != words - 1) itemlist.items[x].relation = itemlist.items[x].relation + " ";
                } }
            if (parm.compareTo("COVERAGE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].coverage = itemlist.items[x].coverage + st.nextToken();
                if (i != words - 1) itemlist.items[x].coverage = itemlist.items[x].coverage + " ";
                } }
            if (parm.compareTo("RIGHTS") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].rights = itemlist.items[x].rights + st.nextToken();
                if (i != words - 1) itemlist.items[x].rights = itemlist.items[x].rights + " ";
                } }
            if (parm.compareTo("DOMAIN") == 0) {
                itemlist.items[x].domain = st.nextToken();
                }
            if (parm.compareTo("SIZE_PAGE") == 0) {
                itemlist.items[x].size_page = st.nextToken();
                }
            if (parm.compareTo("SIZE_BYTE") == 0) {
                itemlist.items[x].size_byte = st.nextToken();
                }
            if (parm.compareTo("IMAGE_LOGO") == 0) {
                itemlist.items[x].image_logo = st.nextToken();
                }
            if (parm.compareTo("TEMPLATE") == 0) {
                itemlist.items[x].template = st.nextToken();
                }
            if (parm.compareTo("IMAGE_WELLTHUMBED") == 0) {
                itemlist.items[x].image_wellthumbed = st.nextToken();
                }
            if (parm.compareTo("DUST_LEVEL") == 0) {
                itemlist.items[x].dust_level = st.nextToken();
                }
            if (parm.compareTo("COLOR_FRONT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_front = itemlist.items[x].color_front + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_front = itemlist.items[x].color_front + " ";
                } }
            if (parm.compareTo("COLOR_TOP") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_top = itemlist.items[x].color_top + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_top = itemlist.items[x].color_top + " ";
                } }
            if (parm.compareTo("COLOR_SPINE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_spine = itemlist.items[x].color_spine + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_spine = itemlist.items[x].color_spine + " ";
                } }
            if (parm.compareTo("COLOR_TITLE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_title = itemlist.items[x].color_title + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_title = itemlist.items[x].color_title + " ";
                } }
            if (parm.compareTo("COLOR_CREATOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_creator = itemlist.items[x].color_creator + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_creator = itemlist.items[x].color_creator + " ";
                } }
                if (parm.compareTo("HIGHLIGHTING") == 0) {
                itemlist.items[x].highlighting = st.nextToken();
                }
                if (parm.compareTo("XPOS") == 0) {
                itemlist.items[x].xpos = st.nextToken();
                }
                if (parm.compareTo("YPOS") == 0) {
                itemlist.items[x].ypos = st.nextToken();
                }
                if (parm.compareTo("ZPOS") == 0) {
                itemlist.items[x].zpos = st.nextToken();
                }

      }
      else if (Settings.ERROR_DETAILS_ON) System.out.println("WARNING: Invalid Line detected: $" + line);
      }

    }

    }// end while

    ServerMulti1to1.Lib_loaded = true;

    } catch (IOException io) {System.out.println("ERROR: I/O Error!");  }
    } catch (IOException io) {System.out.println("caught IO Exception.");}

  } catch (IOException io) {System.out.println("ERROR: File not found. File: " + Filename);}
    catch (SecurityException sec) {System.out.println(sec.getMessage());}

  } // end if

  else {

  try {RandomAccessFile file = new RandomAccessFile(Filename, "r");

    // check out number of items in file and init Node Array
    itemlist.init_items(countEntriesFILE(Filename));

    String line;                                           // buffer for lines

    try {

    while ((line = file.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            // read shelve description block------------------------------------
            if (parm.compareTo("SHELVE_ROWS") == 0) {
                shelve_rows = Integer.valueOf(st.nextToken()).intValue();
                shelve_rows_flag = true;
                }
            if (parm.compareTo("SHELVE_COLUMNS") == 0) {
                shelve_columns = Integer.valueOf(st.nextToken()).intValue();
                if (shelve_rows_flag) {
                    if ((shelve_columns > 0) && (shelve_rows > 0)) {
                      map.init_Map(shelve_columns,shelve_rows);
                      map.valid = true;
                      can_write = true;
                      }
                    }
                }
            if  (can_write) {

            if (parm.compareTo("SHELVE_LABEL") == 0) {
                curr_x_pos++;
                if (curr_x_pos > map.x_dim - 1) { curr_y_pos++; curr_x_pos = 0; }
                if (curr_y_pos <= map.y_dim - 1) {
                    map.labels[curr_x_pos][curr_y_pos] = "";
                    for (i = 0; i < words; i++) {
                      map.labels[curr_x_pos][curr_y_pos] = map.labels[curr_x_pos][curr_y_pos] + st.nextToken();
                      if (i != words - 1) map.labels[curr_x_pos][curr_y_pos] = map.labels[curr_x_pos][curr_y_pos] + " ";
                    }
                }
              }
            if (parm.compareTo("SHELVE_DESCR") == 0) {
                if (curr_y_pos <= map.y_dim - 1) {
                    map.descr[curr_x_pos][curr_y_pos] = "";
                    for (i = 0; i < words; i++) {
                      map.descr[curr_x_pos][curr_y_pos] = map.descr[curr_x_pos][curr_y_pos] + st.nextToken();
                      if (i != words - 1) map.descr[curr_x_pos][curr_y_pos] = map.descr[curr_x_pos][curr_y_pos] + " ";
                    }
                }
              }
            }
            // -----------------------------------------------------------------
            if (parm.compareTo("TITLE") == 0) {          // parse Keywords sequentially
                x++;
                itemlist.items[x].Key = x;
                for (i = 0; i < words; i++) {
                itemlist.items[x].title = itemlist.items[x].title + st.nextToken();
                if (i != words - 1) itemlist.items[x].title = itemlist.items[x].title + " ";
                } }
            if (parm.compareTo("WIDTH") == 0) {
                itemlist.items[x].width = st.nextToken();
                }
            if (parm.compareTo("HEIGHT") == 0) {
                itemlist.items[x].height = st.nextToken();
                }
            if (parm.compareTo("CREATOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].creator = itemlist.items[x].creator + st.nextToken();
                if (i != words - 1) itemlist.items[x].creator = itemlist.items[x].creator + " ";
                } }
            if (parm.compareTo("SUBJECT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].subject = itemlist.items[x].subject + st.nextToken();
                if (i != words - 1) itemlist.items[x].subject = itemlist.items[x].subject + " ";
                } }
            if (parm.compareTo("DESCRIPTION") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].description = itemlist.items[x].description + st.nextToken();
                if (i != words - 1) itemlist.items[x].description = itemlist.items[x].description + " ";
                } }
            if (parm.compareTo("PUBLISHER") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].publisher = itemlist.items[x].publisher + st.nextToken();
                if (i != words - 1) itemlist.items[x].publisher = itemlist.items[x].publisher + " ";
                } }
            if (parm.compareTo("CONTRIBUTOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].contributor = itemlist.items[x].contributor + st.nextToken();
                if (i != words - 1) itemlist.items[x].contributor = itemlist.items[x].contributor + " ";
                } }
            if (parm.compareTo("DATE") == 0) {
                itemlist.items[x].date = st.nextToken();
                }
            if (parm.compareTo("TYPE") == 0) {
                itemlist.items[x].type = st.nextToken();
                }
            if (parm.compareTo("FORMAT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].format = itemlist.items[x].format + st.nextToken();
                if (i != words - 1) itemlist.items[x].format = itemlist.items[x].format + " ";
                } }
            if (parm.compareTo("IDENTIFIER") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].identifier = itemlist.items[x].identifier + st.nextToken();
                if (i != words - 1) itemlist.items[x].identifier = itemlist.items[x].identifier + " ";
                } }
            if (parm.compareTo("SOURCE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].source = itemlist.items[x].source + st.nextToken();
                if (i != words - 1) itemlist.items[x].source = itemlist.items[x].source + " ";
                } }
            if (parm.compareTo("LANGUAGE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].language = itemlist.items[x].language + st.nextToken();
                if (i != words - 1) itemlist.items[x].language = itemlist.items[x].language + " ";
                } }
            if (parm.compareTo("RELATION") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].relation = itemlist.items[x].relation + st.nextToken();
                if (i != words - 1) itemlist.items[x].relation = itemlist.items[x].relation + " ";
                } }
            if (parm.compareTo("COVERAGE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].coverage = itemlist.items[x].coverage + st.nextToken();
                if (i != words - 1) itemlist.items[x].coverage = itemlist.items[x].coverage + " ";
                } }
            if (parm.compareTo("RIGHTS") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].rights = itemlist.items[x].rights + st.nextToken();
                if (i != words - 1) itemlist.items[x].rights = itemlist.items[x].rights + " ";
                } }
            if (parm.compareTo("DOMAIN") == 0) {
                itemlist.items[x].domain = st.nextToken();
                }
            if (parm.compareTo("SIZE_PAGE") == 0) {
                itemlist.items[x].size_page = st.nextToken();
                }
            if (parm.compareTo("SIZE_BYTE") == 0) {
                itemlist.items[x].size_byte = st.nextToken();
                }
            if (parm.compareTo("IMAGE_LOGO") == 0) {
                itemlist.items[x].image_logo = st.nextToken();
                }
            if (parm.compareTo("TEMPLATE") == 0) {
                itemlist.items[x].template = st.nextToken();
                }
            if (parm.compareTo("IMAGE_WELLTHUMBED") == 0) {
                itemlist.items[x].image_wellthumbed = st.nextToken();
                }
            if (parm.compareTo("DUST_LEVEL") == 0) {
                itemlist.items[x].dust_level = st.nextToken();
                }
            if (parm.compareTo("COLOR_FRONT") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_front = itemlist.items[x].color_front + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_front = itemlist.items[x].color_front + " ";
                } }
            if (parm.compareTo("COLOR_TOP") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_top = itemlist.items[x].color_top + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_top = itemlist.items[x].color_top + " ";
                } }
            if (parm.compareTo("COLOR_SPINE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_spine = itemlist.items[x].color_spine + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_spine = itemlist.items[x].color_spine + " ";
                } }
            if (parm.compareTo("COLOR_TITLE") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_title = itemlist.items[x].color_title + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_title = itemlist.items[x].color_title + " ";
                } }
            if (parm.compareTo("COLOR_CREATOR") == 0) {
                for (i = 0; i < words; i++) {
                itemlist.items[x].color_creator = itemlist.items[x].color_creator + st.nextToken();
                if (i != words - 1) itemlist.items[x].color_creator = itemlist.items[x].color_creator + " ";
                } }
                if (parm.compareTo("HIGHLIGHTING") == 0) {
                itemlist.items[x].highlighting = st.nextToken();
                }
                if (parm.compareTo("XPOS") == 0) {
                itemlist.items[x].xpos = st.nextToken();
                }
                if (parm.compareTo("YPOS") == 0) {
                itemlist.items[x].ypos = st.nextToken();
                }
                if (parm.compareTo("ZPOS") == 0) {
                itemlist.items[x].zpos = st.nextToken();
                }

      }
      else if (Settings.ERROR_DETAILS_ON) System.out.println("WARNING: Invalid Line detected: $" + line + "");
      }

    }

    }// end while

    ServerMulti1to1.Lib_loaded = true;

    } catch (IOException io) { System.out.println("caught IO Exception."); }

  } catch (IOException io) {System.out.println("ERROR: File not found. File: " + Filename + "");}
    catch (SecurityException sec) {System.out.println(sec.getMessage());}

  } // end else

  
}
//------------------------------------------------------------------------------
public static int countEntriesFILE (String Filename) {
  int count = 0;
  String line;

  try { RandomAccessFile file = new RandomAccessFile(Filename, "r");

    try {

    while ((line = file.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword

          if (parm.compareTo("TITLE") == 0) {              // if we find the mandatory keyword "VEC_ID" we can increase the counter.
                count++;
                }
      }
     }
    }
    }// end while
    } catch (IOException io) {System.out.println("I/O ERROR! File: " + Filename + "");}
    } catch (IOException io) {}

  return count;
}
//------------------------------------------------------------------------------
public static int countEntriesURL (String Filename) {
  int count = 0;
  String line;
  InputStream data1;
  DataInputStream data2;
  try {URL fileURL = new URL(Filename);

    try {data1 = fileURL.openStream();
         data2 = new DataInputStream(data1);

    while ((line = data2.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword

          if (parm.compareTo("TITLE") == 0) {              // if we find the mandatory keyword "VEC_ID" we can increase the counter.
                count++;
                }
      }
     }
    }
    }// end while
    } catch (IOException io) {System.out.println("caught IO Exception.");}
    } catch (IOException io) {System.out.println("ERROR: File not found. File: " + Filename);}
    catch (SecurityException sec) {System.out.println(sec.getMessage());}

  return count;
  }
//------------------------------------------------------------------------------
}

