//------------------------------------------------------------------------------
// libViewer Pro Package Extension
// Server for Dublin Core Library Files
//------------------------------------------------------------------------------
package Server1to1;

import java.net.*;
import java.io.*;
import java.util.*;

public class Server1to1 {

  static boolean listening = true;

  public Server1to1 () {

  }

  public static void main(String[] args) {

    Settings.loadPrefs();

    System.out.println("Server1to1 V0.1 started");

    ServerSocket serverSocket = null;

        try {
            serverSocket = new ServerSocket(Settings.PORT);
        } catch (IOException e) {
            System.err.println("Could not listen on port: " + Settings.PORT);
            System.exit(-1);
        }

        System.out.println("Server1to1 V0.1 is listening on Port " + Settings.PORT + " for requests.");

    while (listening) {

        Socket clientSocket = null;
        try {  clientSocket = serverSocket.accept(); 
        } catch (IOException e) { System.err.println("Accept failed."); }

        new ServerMulti1to1(clientSocket).start();

    }

    try { serverSocket.close(); } catch (Exception e) { System.out.println("Close Server socket failed.");}
}

} // 1to1-Server

